formatGenomicPosition <- function( x, unit = "Mb", divisor = 1000000, digits = 3, nsmall = 1 ){
  x = as.character(x)
  return(
    sapply(
      strsplit(x, split=":"),
      function(y) paste(
        format(
          as.numeric(y[1])/divisor,
          digits = digits,
          nsmall=nsmall), unit, sep = ""))
    )
}

encodeDNAString <- function( ds ){
  ret = log2(as.numeric(ds))
  ret[ !(ret %in% c(0,1,2,3)) ] = -1
  return(ret)
}
